## 2025-12-26-23-55-14-ceph-main.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22.1)

project(ceph
  VERSION 20.0.0
  LANGUAGES CXX C ASM)

foreach(policy CMP0127 CMP0135 CMP0175)
  if(POLICY ${policy})
    cmake_policy(SET ${policy} NEW)
  endif()
endforeach()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

if(NOT CMAKE_BUILD_TYPE)
  if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
    message(WARNING "CMAKE_BUILD_TYPE not specified, assuming CMAKE_BUILD_TYPE=Debug because .git exists.")
    set(default_build_type "Debug")
  else()
    message(WARNING "CMAKE_BUILD_TYPE not specified, setting to RelWithDebInfo because .git does NOT exist.")
    set(default_build_type "RelWithDebInfo")
  endif()
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
  STRING "BUILD_TYPE is ${default_build_type}, other options are: RelWithDebInfo, Release, and MinSizeRel." FORCE)
endif()
message(STATUS "BUILD_TYPE is ${CMAKE_BUILD_TYPE}")
set(CEPH_BUILD_TYPE ${CMAKE_BUILD_TYPE})

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(LINUX ON)
  FIND_PACKAGE(Threads)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set(FREEBSD ON)
  FIND_PACKAGE(Threads)
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")

if(WIN32)
  # The Windows headers (e.g. coming from mingw or the Windows SDK) check
  # the targeted Windows version. The availability of certain functions and
  # structures will depend on it.
  set(WIN32_WINNT "0x0A00" CACHE STRING "Targeted Windows version.")
  add_definitions(
    -D_WIN32_WINNT=${WIN32_WINNT}
    -DFMT_USE_TZSET=0
  )
  # In order to avoid known winpthread issues, we're using the Boost
  # shared mutex implementation. This isn't required with llvm/libc++.
  # https://github.com/msys2/MINGW-packages/issues/3319
  if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    add_definitions(
      -DBOOST_THREAD_PROVIDES_GENERIC_SHARED_MUTEX_ON_WIN
      -DBOOST_THREAD_V2_SHARED_MUTEX
    )
  endif()
  set(Boost_THREADAPI "win32")
endif()

if(MINGW)
  string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,-allow-multiple-definition")
  string(APPEND CMAKE_EXE_LINKER_FLAGS " -Wl,-allow-multiple-definition")

  # By default, cmake generates import libs for executables. The issue is that
  # for rados and rbd, the executable import lib overrides the library import lib.
  # For example, for rados.exe, it will end up generating a librados.dll.a import lib.
  # We're providing custom rules to disable import libs for executables.
  set(CMAKE_C_LINK_EXECUTABLE
    "<CMAKE_C_COMPILER> <FLAGS> <CMAKE_C_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> -o <TARGET> ${CMAKE_GNULD_IMAGE_VERSION} <LINK_LIBRARIES>")
  set(CMAKE_CXX_LINK_EXECUTABLE
    "<CMAKE_CXX_COMPILER> <FLAGS> <CMAKE_CXX_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> -o <TARGET> ${CMAKE_GNULD_IMAGE_VERSION} <LINK_LIBRARIES>")

  link_directories(${MINGW_LINK_DIRECTORIES})
endif()

option(WITH_CCACHE "Build with ccache.")
if(WITH_CCACHE)
  if(CMAKE_C_COMPILER_LAUNCHER OR CMAKE_CXX_COMPILER_LAUNCHER)
    message(WARNING "Compiler launcher already set. stop configuring ccache")
  else()
    find_program(CCACHE_EXECUTABLE ccache
      REQUIRED)
    message(STATUS "Building with ccache: ${CCACHE_EXECUTABLE}, CCACHE_DIR=$ENV{CCACHE_DIR}")
    set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE_EXECUTABLE})
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE_EXECUTABLE})
  endif()
endif(WITH_CCACHE)

option(WITH_SCCACHE "Build with sccache.")
if(WITH_SCCACHE)
  find_program(SCCACHE_EXECUTABLE sccache
    REQUIRED)
  if(NOT NINJA_MAX_COMPILE_JOBS)
    if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.19")
      execute_process(
        COMMAND "sccache" "--dist-status"
        OUTPUT_VARIABLE sccache_dist_status
      )
      string(
        JSON sccache_cores
        ERROR_VARIABLE sccache_dist_status_error
        GET "${sccache_dist_status}" SchedulerStatus 1 num_cpus
      )
      string(FIND "${sccache_dist_status}" "disabled" find_result)
      if(find_result EQUAL -1)
        message(STATUS "Using sccache with distributed compilation. Effective cores: ${sccache_cores}")
        set(NINJA_MAX_COMPILE_JOBS ${sccache_cores})
        set(NINJA_MAX_LINK_JOBS ${sccache_cores})
      else()
        message(WARNING "Using sccache, but it is not configured for distributed complilation")
      endif()
    else()
      message(WARNING "Using sccache, but cannot determine maximum job value since cmake version is <3.19")
    endif()
  endif()
  message(STATUS "Building with sccache: ${SCCACHE_EXECUTABLE}, SCCACHE_CONF=$ENV{SCCACHE_CONF}")
  set(CMAKE_C_COMPILER_LAUNCHER ${SCCACHE_EXECUTABLE})
  set(CMAKE_CXX_COMPILER_LAUNCHER ${SCCACHE_EXECUTABLE})
endif(WITH_SCCACHE)

option(WITH_MANPAGE "Build man pages." ON)
if(WITH_MANPAGE)
  find_program(SPHINX_BUILD
    NAMES sphinx-build sphinx-build-3
    REQUIRED)
endif(WITH_MANPAGE)

include_directories(
  ${PROJECT_BINARY_DIR}/src/include
  ${PROJECT_SOURCE_DIR}/src)

if(WIN32)
  include_directories(
    ${PROJECT_SOURCE_DIR}/src/include/win32)
  # Boost complains if winsock2.h (or windows.h) is included before asio.hpp.
  add_compile_options("SHELL:-include winsock_wrapper.h")
  # Boost is also defining some of the errno values, we'll have
  # to avoid mismatches.
  add_compile_options("SHELL:-include win32_errno.h")
endif()

if(FREEBSD)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  list(APPEND CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif(FREEBSD)


#put all the libs and binaries in one place
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

include(GNUInstallDirs)
include(CephChecks)
if(CMAKE_GENERATOR MATCHES Ninja)
  include(LimitJobs)
endif()

set(CEPH_MAN_DIR "share/man" CACHE STRING "Install location for man pages (relative to prefix).")

option(ENABLE_SHARED "build shared libraries" ON)
if(ENABLE_SHARED)
  set(CEPH_SHARED SHARED)
else(ENABLE_SHARED)
  set(CEPH_SHARED STATIC)
endif(ENABLE_SHARED)
set(CMAKE_POSITION_INDEPENDENT_CODE ${ENABLE_SHARED})

option(WITH_STATIC_LIBSTDCXX "Link against libstdc++ statically" OFF)
if(WITH_STATIC_LIBSTDCXX)
  if(NOT CMAKE_COMPILER_IS_GNUCXX)
    message(FATAL_ERROR "Please use GCC to enable WITH_STATIC_LIBSTDCXX")
  endif()
  set(static_linker_flags "-static-libstdc++ -static-libgcc")
  string(APPEND CMAKE_SHARED_LINKER_FLAGS " ${static_linker_flags}")
  string(APPEND CMAKE_EXE_LINKER_FLAGS " ${static_linker_flags}")
  unset(static_linker_flags)
  set(GPERFTOOLS_USE_STATIC_LIBS TRUE)
endif()
include(CheckCxxAtomic)
if(NOT HAVE_CXX11_ATOMIC)
  string(APPEND CMAKE_CXX_STANDARD_LIBRARIES
    " ${LIBATOMIC_LINK_FLAGS}")
endif()

option(WITH_RDMA "Enable RDMA in async messenger" ON)
if(WITH_RDMA)
  find_package(verbs REQUIRED)
  set(HAVE_VERBS ${VERBS_FOUND})
  find_package(rdmacm REQUIRED)
  set(HAVE_RDMACM ${RDMACM_FOUND})
  set(HAVE_RDMA TRUE)
endif()

find_package(Backtrace)

option(WITH_RBD "Enable RADOS Block Device related targets" ON)

if(LINUX)
  find_package(udev REQUIRED)
  set(HAVE_UDEV ${UDEV_FOUND})
  find_package(blkid REQUIRED)
  set(HAVE_BLKID ${BLKID_FOUND})
  find_package(keyutils REQUIRED)
  set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
elseif(FREEBSD)
  set(HAVE_UDEV OFF)
  set(HAVE_LIBAIO OFF)
  set(HAVE_LIBDML OFF)
  set(HAVE_BLKID OFF)
  set(HAVE_KEYUTILS OFF)
else()
  set(HAVE_UDEV OFF)
  set(HAVE_BLKID OFF)
endif(LINUX)

option(WITH_OPENLDAP "OPENLDAP is here" ON)
if(WITH_OPENLDAP)
  find_package(OpenLDAP REQUIRED)
  set(HAVE_OPENLDAP ${OpenLDAP_FOUND})
endif()

option(WITH_GSSAPI "GSSAPI/KRB5 is here" OFF)
if(WITH_GSSAPI)
  find_package(GSSApi REQUIRED)
  set(HAVE_GSSAPI ${GSSApi_FOUND})
endif()

option(WITH_FUSE "Fuse is here" ON)
if(WITH_FUSE)
  find_package(FUSE REQUIRED)
  set(HAVE_LIBFUSE ${FUSE_FOUND})
endif()

option(WITH_DOKAN "Dokan is here" OFF)

option(WITH_XFS "XFS is here" ON)
if(WITH_XFS)
  find_package(xfs)
  set(HAVE_LIBXFS ${XFS_FOUND})
endif()

option(WITH_BLUESTORE "Bluestore OSD backend" ON)
if(WITH_BLUESTORE)
  if(LINUX)
    find_package(aio)
    set(HAVE_LIBAIO ${AIO_FOUND})
  elseif(FREEBSD)
    # POSIX AIO is integrated into FreeBSD kernel, and exposed by libc.
    set(HAVE_POSIXAIO ON)
  endif()
endif()

# libcryptsetup is only available on linux
if(WITH_RBD AND LINUX)
  find_package(libcryptsetup 2.0.5 REQUIRED)
  set(HAVE_LIBCRYPTSETUP ${LIBCRYPTSETUP_FOUND})
endif()

# libnbd
if(WITH_RBD AND NOT WIN32)
  find_package(libnbd 1.0 REQUIRED)
  set(HAVE_LIBNBD ${LIBNBD_FOUND})
endif()

include(CMakeDependentOption)

CMAKE_DEPENDENT_OPTION(WITH_LIBURING "Enable io_uring bluestore backend" ON
  "WITH_BLUESTORE;HAVE_LIBAIO" OFF)
set(HAVE_LIBURING ${WITH_LIBURING})

CMAKE_DEPENDENT_OPTION(WITH_SYSTEM_LIBURING "Require and build with system liburing" OFF
  "HAVE_LIBAIO;WITH_BLUESTORE" OFF)

if(WITH_LIBURING)
  if(WITH_SYSTEM_LIBURING)
    find_package(uring REQUIRED)
  else()
    include(Builduring)
    build_uring()
  endif()
  # enable uring in boost::asio

  if(CMAKE_SYSTEM_VERSION VERSION_GREATER_EQUAL "5.10")
    add_compile_definitions("BOOST_ASIO_HAS_IO_URING")
  endif()
endif()

CMAKE_DEPENDENT_OPTION(WITH_BLUESTORE_PMEM "Enable PMDK libraries" OFF
  "WITH_BLUESTORE" OFF)
if(WITH_BLUESTORE_PMEM)
  find_package(dml)
  set(HAVE_LIBDML ${DML_FOUND})
endif()

CMAKE_DEPENDENT_OPTION(WITH_RBD_MIRROR "Enable build for rbd-mirror daemon executable" OFF
    "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_MIGRATION_FORMAT_QCOW_V1
  "Enable librbd QCOW v1 migration format support" ON
  "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_RWL "Enable librbd persistent write back cache" OFF
  "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_SSD_CACHE "Enable librbd persistent write back cache for SSDs" OFF
    "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_SYSTEM_PMDK "Require and build with system PMDK" OFF
  "WITH_RBD_RWL OR WITH_BLUESTORE_PMEM" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_UBBD "Enable ubbd support for rbd device utility" OFF
    "WITH_RBD" OFF)

if(WITH_RBD_UBBD)
  include(BuildUBBD)
  build_ubbd()
endif()

if(WITH_BLUESTORE_PMEM)
  set(HAVE_BLUESTORE_PMEM ON)
endif()

CMAKE_DEPENDENT_OPTION(WITH_SPDK "Enable SPDK" OFF
  "CMAKE_SYSTEM_PROCESSOR MATCHES i386|i686|amd64|x86_64|AMD64|aarch64" OFF)
if(WITH_SPDK)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using SPDK")
  endif()
  include(BuildSPDK)
  build_spdk()
  set(HAVE_SPDK TRUE)
endif(WITH_SPDK)

if(WITH_BLUESTORE)
  if(NOT AIO_FOUND AND NOT HAVE_POSIXAIO AND NOT WITH_SPDK AND NOT WITH_BLUESTORE_PMEM)
    message(SEND_ERROR "WITH_BLUESTORE is ON, "
      "but none of the bluestore backends is enabled. "
      "Please install libaio, or enable WITH_SPDK or WITH_BLUESTORE_PMEM (experimental)")
  endif()
endif()

option(WITH_BLUEFS "libbluefs library" OFF)

CMAKE_DEPENDENT_OPTION(WITH_QATLIB "Enable QAT with qatlib" ON
  "CMAKE_SYSTEM_PROCESSOR MATCHES amd64|x86_64|AMD64" OFF)
option(WITH_SYSTEM_QATLIB "Use system packages for qatlib" OFF)
option(WITH_QATDRV "Enable QAT with out-of-tree driver" OFF)
CMAKE_DEPENDENT_OPTION(WITH_QATZIP "Enable QATzip" ON
  "CMAKE_SYSTEM_PROCESSOR MATCHES amd64|x86_64|AMD64" OFF)
option(WITH_SYSTEM_QATZIP "Use system packages for QATzip" OFF)

if(WITH_QATDRV)
  find_package(QatDrv REQUIRED COMPONENTS qat_s usdm_drv_s)
  set(HAVE_QAT TRUE)
elseif(WITH_QATLIB)
  if(NOT WITH_SYSTEM_QATLIB)
    include(BuildQAT)
    build_qat()
  endif()
  find_package(QAT REQUIRED)
  if(NOT WITH_SYSTEM_QATLIB)
    add_dependencies(QAT::qat qatlib_ext)
    add_dependencies(QAT::usdm qatlib_ext)
  endif()
  set(HAVE_QAT TRUE)
endif()

if(WITH_QATZIP)
  if(NOT HAVE_QAT)
    message(FATAL_ERROR "WITH_QATZIP requires WITH_QATLIB or WITH_QATDRV")
  endif()
  if(NOT WITH_SYSTEM_QATZIP)
    include(BuildQATzip)
    build_qatzip()
    # qatzip build depends on qatlib
    add_dependencies(qatzip_ext QAT::qat)
  endif()
  find_package(QATzip REQUIRED)
  if(NOT WITH_SYSTEM_QATZIP)
    add_dependencies(QAT::zip qatzip_ext)
  endif()
  set(HAVE_QATZIP TRUE)
endif(WITH_QATZIP)

=== src/client/CMakeLists.txt ===
set(libclient_srcs
  Client.cc
  Dentry.cc
  Fh.cc
  Inode.cc
  MetaRequest.cc
  ClientSnapRealm.cc
  MetaSession.cc
  Trace.cc
  posix_acl.cc
  Delegation.cc
  FSCrypt.cc)
add_library(client STATIC ${libclient_srcs})
target_link_libraries(client
  legacy-option-headers
  osdc
  Boost::locale
  ICU::uc
  ICU::i18n
  )

=== src/common/CMakeLists.txt ===
add_library(common_buffer_obj OBJECT
  buffer.cc)

add_library(common_texttable_obj OBJECT
  TextTable.cc)

add_library(common_prioritycache_obj OBJECT
  PriorityCache.cc)
target_link_libraries(common_prioritycache_obj legacy-option-headers)

if(WIN32)
  add_library(dlfcn_win32 STATIC win32/dlfcn.cc win32/errno.cc)
endif()

add_subdirectory(io_exerciser)
add_subdirectory(json)
add_subdirectory(options)

set(common_srcs
  AsyncOpTracker.cc
  BackTrace.cc
  CompatSet.cc
  ConfUtils.cc
  Cycles.cc
  CDC.cc
  DecayCounter.cc
  FastCDC.cc
  Finisher.cc
  FixedCDC.cc
  Formatter.cc
  Graylog.cc
  JSONFormatter.cc
  HTMLFormatter.cc
  HeartbeatMap.cc
  LogClient.cc
  LogEntry.cc
  ostream_temp.cc
  OutputDataSocket.cc
  PluginRegistry.cc
  Readahead.cc
  RefCountedObj.cc
  SloppyCRCMap.cc
  TableFormatter.cc
  Thread.cc
  Throttle.cc
  Timer.cc
  TracepointProvider.cc
  TrackedOp.cc
  WorkQueue.cc
  XMLFormatter.cc
  admin_socket.cc
  admin_socket_client.cc
  assert.cc
  bit_str.cc
  bloom_filter.cc
  ceph_argparse.cc
  ceph_context.cc
  ceph_crypto.cc
  ceph_frag.cc
  ceph_fs.cc
  ceph_hash.cc
  ceph_json.cc
  ceph_strings.cc
  ceph_releases.cc
  ceph_time.cc
  cmdparse.cc
  code_environment.cc
  common_init.cc
  compat.cc
  config.cc
  config_values.cc
  dout.cc
  entity_name.cc
  environment.cc
  errno.cc
  escape.cc
  fd.cc
  fs_types.cc
  hex.cc
  histogram.cc
  hobject.cc
  hostname.cc
  ipaddr.cc
  iso_8601.cc
  mempool.cc
  mime.c
  numa.cc
  openssl_opts_handler.cc
  options.cc
  page.cc
  perf_counters.cc
  perf_counters_cache.cc
  perf_counters_collection.cc
  perf_counters_key.cc
  perf_histogram.cc
  pick_address.cc
  prime.cc
  random_string.cc
  reverse.c
  run_cmd.cc
  scrub_types.cc
  signal.cc
  snap_types.cc
  str_list.cc
  str_map.cc
  strtol.cc
  types.cc
  url_escape.cc
  pretty_binary.cc
  utf8.c
  util.cc
  version.cc
  mclock_common.cc
  tcp_info.cc)

if(WITH_CPUTRACE)
  list(APPEND common_srcs
    cputrace.cc)
endif()

include_directories(${CMAKE_SOURCE_DIR}/src/dmclock/support/src)

if(WITH_SYSTEMD)
  list(APPEND common_srcs
    Journald.cc)
endif()

if(WITH_CEPH_DEBUG_MUTEX)
  list(APPEND common_srcs
    lockdep.cc
    mutex_debug.cc
    condition_variable_debug.cc
    shared_mutex_debug.cc)
endif()

if(WIN32)
  if(MINGW)
    set(CMAKE_MC_COMPILER x86_64-w64-mingw32-windmc)
    set(CMAKE_RC_COMPILER x86_64-w64-mingw32-windres)
  endif()

  add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/src/common/event_logging.h
    COMMAND ${CMAKE_MC_COMPILER} -b -e h -h ${CMAKE_BINARY_DIR}/src/common/
      -r ${CMAKE_BINARY_DIR}/src/common ${CMAKE_SOURCE_DIR}/src/common/win32/event_logging.mc
    COMMAND ${CMAKE_RC_COMPILER} ${CMAKE_BINARY_DIR}/src/common/event_logging.rc
      -o ${CMAKE_BINARY_DIR}/src/common/event_logging.o
    COMMAND ${CMAKE_CXX_COMPILER} -o ${CMAKE_BINARY_DIR}/bin/event_logging.dll -shared
      ${CMAKE_BINARY_DIR}/src/common/event_logging.o
    DEPENDS ${CMAKE_SOURCE_DIR}/src/common/win32/event_logging.mc)

  set_source_files_properties(${CMAKE_SOURCE_DIR}/src/common/win32/syslog.cc
    APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_BINARY_DIR}/src/common/event_logging.h)

  include_directories(SYSTEM "${CMAKE_BINARY_DIR}/src/common/")

  list(APPEND common_srcs
    win32/blkdev.cc
    win32/dns_resolve.cc
    win32/ifaddrs.cc
    win32/registry.cc
    win32/service.cc
    win32/SubProcess.cc
    win32/syslog.cc)
else()
  list(APPEND common_srcs
    blkdev.cc
    dns_resolve.cc
    linux_version.c
    SubProcess.cc)
endif()

set_source_files_properties(${CMAKE_SOURCE_DIR}/src/common/version.cc
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_BINARY_DIR}/src/include/ceph_ver.h)

if(HAS_VTA)
  set_source_files_properties(
    config.cc
    options.cc
    PROPERTIES COMPILE_FLAGS -fno-var-tracking-assignments)
endif()

if(FREEBSD)
  list(APPEND common_srcs freebsd_errno.cc)
elseif(APPLE)
  list(APPEND common_srcs darwin_errno.cc)
elseif(SUN)
  list(APPEND common_srcs solaris_errno.cc)
elseif(AIX)
  list(APPEND common_srcs aix_errno.cc)
elseif(WIN32)
  list(APPEND common_srcs win32/errno.cc)
  list(APPEND common_srcs win32/wstring.cc)
endif()

if(WITH_EVENTTRACE)
  list(APPEND common_srcs EventTrace.cc)
endif()

add_library(common-common-objs OBJECT
  ${common_srcs})
# Let's not rely on the default system headers and point Cmake to the
# retrieved OpenSSL location. This is especially important when cross
# compiling (e.g. targeting Windows).
target_include_directories(common-common-objs PRIVATE ${OPENSSL_INCLUDE_DIR})
# for options.cc
target_compile_definitions(common-common-objs PRIVATE
  "CMAKE_INSTALL_LIBDIR=\"${CMAKE_INSTALL_LIBDIR}\""
  "CEPH_INSTALL_FULL_PKGLIBDIR=\"${CEPH_INSTALL_FULL_PKGLIBDIR}\""
  "CEPH_INSTALL_DATADIR=\"${CEPH_INSTALL_DATADIR}\""
  $<TARGET_PROPERTY:${FMT_LIB},INTERFACE_COMPILE_DEFINITIONS>)
target_link_libraries(common-common-objs PUBLIC legacy-option-headers)
if(WITH_BREAKPAD)
  target_link_libraries(common-common-objs PUBLIC
    Breakpad::client)
endif()

set(common_mountcephfs_srcs
  armor.c
  safe_io.c
  module.c
  addr_parsing.c)
add_library(common_mountcephfs_objs OBJECT
  ${common_mountcephfs_srcs})


set(crc32_srcs
  crc32c.cc
  crc32c_intel_baseline.c
  sctp_crc32.c)
if(HAVE_INTEL)
  list(APPEND crc32_srcs
    crc32c_intel_fast.c)
  if(HAVE_NASM_X64)
    set(CMAKE_ASM_FLAGS "-i ${PROJECT_SOURCE_DIR}/src/isa-l/include/ ${CMAKE_ASM_FLAGS}")
    list(APPEND crc32_srcs
      ${PROJECT_SOURCE_DIR}/src/isa-l/crc/crc32_iscsi_00.asm
      ${PROJECT_SOURCE_DIR}/src/isa-l/crc/crc32_iscsi_01.asm
      crc32c_intel_fast_zero_asm.s)
  endif(HAVE_NASM_X64)
elseif(HAVE_POWER8)
  list(APPEND crc32_srcs
    crc32c_ppc.c)
  if(HAVE_PPC64LE)
    list(APPEND crc32_srcs
      crc32c_ppc_asm.S
      crc32c_ppc_fast_zero_asm.S)
    set_source_files_properties(crc32c_ppc_asm.S PROPERTIES COMPILE_FLAGS -D__ASSEMBLY__)
  endif(HAVE_PPC64LE)
elseif(HAVE_ARMV8_CRC)
  list(APPEND crc32_srcs
    crc32c_aarch64.c)
elseif(HAVE_S390X)
  list(APPEND crc32_srcs
    crc32c_s390x.c
    crc32c_s390x_le-vx.S
  )
endif(HAVE_INTEL)

add_library(crc32 OBJECT ${crc32_srcs})

if(HAVE_ARMV8_CRC)
  set_target_properties(crc32 PROPERTIES
    COMPILE_FLAGS "${CMAKE_C_FLAGS} ${ARMV8_CRC_COMPILE_FLAGS}")
endif()
target_link_libraries(crc32
  arch)

add_library(common_utf8 STATIC utf8.c)

if(HAVE_KEYUTILS)
  set(parse_secret_srcs
    secret.c)
  add_library(parse_secret_objs OBJECT ${parse_secret_srcs})
endif()

=== src/erasure-code/CMakeLists.txt ===
## erasure code plugins

set(erasure_plugin_dir ${CEPH_INSTALL_PKGLIBDIR}/erasure-code)

#jerasure subdir must be before shec so jerasure & neon obj libs are declared
include_directories(SYSTEM jerasure/jerasure/include)
include_directories(SYSTEM jerasure/gf-complete/include)
include_directories(jerasure)

# legacy jerasure flavors. these are left here for backward compatibility
# and should be removed in future versions
set(jerasure_legacy_flavors generic)
if(HAVE_ARM)
  list(APPEND jerasure_legacy_flavors neon)
endif()
if(HAVE_INTEL)
 list(APPEND jerasure_legacy_flavors sse3 sse4)
endif()

add_subdirectory(jerasure)
add_subdirectory(lrc)
add_subdirectory(shec)
add_subdirectory(clay)
add_subdirectory(consistency)

if(HAVE_NASM_X64_AVX2 OR HAVE_ARMV8_SIMD OR HAS_ALTIVEC)
  set(WITH_EC_ISA_PLUGIN TRUE CACHE BOOL "")
endif()

if(WITH_EC_ISA_PLUGIN)
  add_subdirectory(isa)
  set(EC_ISA_LIB ec_isa)
endif()

add_library(erasure_code OBJECT ErasureCodePlugin.cc)
target_link_libraries(erasure_code $<$<PLATFORM_ID:Windows>:dlfcn_win32>
                      ${CMAKE_DL_LIBS})

add_library(erasure_code_objs OBJECT ErasureCode.cc)

add_custom_target(erasure_code_plugins DEPENDS
    ${EC_ISA_LIB}
    ec_lrc
    ec_jerasure
    ec_shec
    ec_clay)

=== src/json_spirit/CMakeLists.txt ===
add_library(json_spirit OBJECT
  json_spirit_reader.cpp
  json_spirit_writer.cpp)
target_link_libraries(json_spirit common_utf8 Boost::thread)

=== src/os/CMakeLists.txt ===
add_library(os STATIC
  ObjectStore.cc
  Transaction.cc)

target_link_libraries(os
  PRIVATE
    legacy-option-headers
    ${FMT_LIB})

add_subdirectory(memstore)
target_link_libraries(os
  PRIVATE memstore)

if(WITH_BLUESTORE)
  add_subdirectory(bluestore)
  target_link_libraries(os
    PRIVATE bluestore)
endif()

if(WITH_FUSE)
  add_library(fusestore
    FuseStore.cc)
  target_link_libraries(fusestore
    PRIVATE FUSE::FUSE)
  target_link_libraries(os
    PRIVATE fusestore)
endif()

if(WITH_LTTNG)
  add_dependencies(os objectstore-tp)
endif()

if(WITH_JAEGER)
  add_dependencies(os jaeger_base)
  target_link_libraries(os
    PRIVATE jaeger_base)
endif()

if(WITH_BLUESTORE)
  add_executable(ceph-bluestore-tool
    bluestore/bluestore_tool.cc)
  target_link_libraries(ceph-bluestore-tool
    global kv os)
  install(TARGETS ceph-bluestore-tool
    DESTINATION bin)
endif()

=== src/test/CMakeLists.txt ===
include(AddCephTest)

set(UNITTEST_LIBS GMock::Main GMock::GMock GTest::GTest ${CMAKE_THREAD_LIBS_INIT}
    ${GSSAPI_LIBRARIES} ${CMAKE_DL_LIBS})

if(WIN32)
  # Needed by Boost.
  list(APPEND UNITTEST_LIBS ws2_32)
endif()

add_library(unit-main OBJECT unit.cc)
target_include_directories(unit-main PRIVATE
  $<TARGET_PROPERTY:GTest::GTest,INTERFACE_INCLUDE_DIRECTORIES>)

add_subdirectory(common)
add_subdirectory(compressor)
add_subdirectory(crush)
add_subdirectory(direct_messenger)
add_subdirectory(encoding)
add_subdirectory(librados)
add_subdirectory(librados_test_stub)
if(WITH_LIBRADOSSTRIPER)
  add_subdirectory(libradosstriper)
endif()
if(WITH_RBD)
  add_subdirectory(librbd)
endif()
if (WITH_CEPHFS)
  add_subdirectory(mds)
endif()
add_subdirectory(pybind)
add_subdirectory(dokan)
add_subdirectory(libcephfs)

# Not available on Windows for the time being.
if(NOT WIN32)
  # libcls_* dependencies cascade to osd, kv and other libs that are not
  # available on Windows yet.
  add_subdirectory(cls_hello)
  add_subdirectory(cls_cas)
  add_subdirectory(cls_lock)
  add_subdirectory(cls_log)
  add_subdirectory(cls_numops)
  add_subdirectory(cls_sdk)
  if(WITH_RBD)
    add_subdirectory(cls_journal)
    add_subdirectory(cls_rbd)
  endif(WITH_RBD)
  if(WITH_RADOSGW)
    add_subdirectory(cls_rgw)
    add_subdirectory(cls_rgw_gc)
    add_subdirectory(cls_user)
  endif(WITH_RADOSGW)
  add_subdirectory(cls_refcount)
  add_subdirectory(cls_version)
  add_subdirectory(cls_lua)
  add_subdirectory(cls_queue)
  add_subdirectory(cls_2pc_queue)
  add_subdirectory(cls_cmpomap)
  add_subdirectory(cls_fifo)
  add_subdirectory(cls_sem_set)
  add_subdirectory(journal)

  add_subdirectory(erasure-code)
  add_subdirectory(fs)
  add_subdirectory(libcephsqlite)
  add_subdirectory(client)
  add_subdirectory(mon)
  if(WITH_MGR)
    add_subdirectory(mgr)
  endif()
  add_subdirectory(msgr)
  add_subdirectory(neorados)
  add_subdirectory(objectstore)
  add_subdirectory(ObjectMap)
  add_subdirectory(osd)
  add_subdirectory(osdc)
  add_subdirectory(immutable_object_cache)
  add_subdirectory(exporter)
endif(NOT WIN32)

if(WITH_RADOSGW)
  set(rgw_libs rgw_a)
  if(WITH_RADOSGW_AMQP_ENDPOINT)
    list(APPEND rgw_libs amqp_mock)
  endif()
  if(WITH_RADOSGW_KAFKA_ENDPOINT)
    list(APPEND rgw_libs kafka_stub)
  endif()
  add_subdirectory(rgw)
endif(WITH_RADOSGW)
if(WITH_RBD AND NOT WIN32)
add_subdirectory(rbd_mirror)
endif(WITH_RBD AND NOT WIN32)
if(WITH_CRIMSON)
  add_subdirectory(crimson)
endif()
add_subdirectory(system)
if(WITH_FIO)
  add_subdirectory(fio)
endif()
add_subdirectory(lazy-omap-stats)

# test_timers
add_executable(ceph_test_timers
  TestTimers.cc
  )
target_link_libraries(ceph_test_timers global ${BLKID_LIBRARIES} ${CMAKE_DL_LIBS})

# test_signal_handlers
add_executable(ceph_test_signal_handlers
  TestSignalHandlers.cc
  )
target_link_libraries(ceph_test_signal_handlers global ${BLKID_LIBRARIES} ${CMAKE_DL_LIBS})

# test_rewrite_latency
add_executable(ceph_test_rewrite_latency
  test_rewrite_latency.cc
  )
target_link_libraries(ceph_test_rewrite_latency ceph-common)

# test_crypt
add_executable(test_crypto
  testcrypto.cc)
target_link_libraries(test_crypto
  ceph-common)

add_executable(test_build_libcommon buildtest_skeleton.cc)
target_link_libraries(test_build_libcommon ceph-common pthread ${CRYPTO_LIBS} ${EXTRALIBS})

if(WITH_RADOSGW)
  add_executable(test_build_librgw buildtest_skeleton.cc)
  target_link_libraries(test_build_librgw rgw_a pthread ${CRYPTO_LIBS} ${EXTRALIBS})
endif(WITH_RADOSGW)

if(WITH_LIBCEPHFS)
  # From src/test/Makefile-client.am: I dont get this one... testing the osdc build but link in libcephfs?
  add_executable(test_build_libcephfs buildtest_skeleton.cc)
  target_link_libraries(test_build_libcephfs cephfs pthread ceph-common ${CRYPTO_LIBS} ${EXTRALIBS})
endif(WITH_LIBCEPHFS)

add_executable(test_build_librados buildtest_skeleton.cc)
target_link_libraries(test_build_librados librados pthread ${CRYPTO_LIBS} ${EXTRALIBS} ceph-common ${BLKID_LIBRARIES})
if(NOT WIN32)
  target_link_libraries(test_build_librados os osdc osd cls_lock_client)
endif()

# bench_log
set(bench_log_srcs
  bench_log.cc
  )
add_executable(ceph_bench_log
  ${bench_log_srcs}
  )
target_link_libraries(ceph_bench_log global pthread ${BLKID_LIBRARIES} ${CMAKE_DL_LIBS})
if(NOT WIN32)
  target_link_libraries(ceph_bench_log rt)
endif()

if(WITH_SYSTEMD)
  add_executable(ceph_bench_journald_logger
    bench_journald_logger.cc)
  target_link_libraries(ceph_bench_journald_logger ceph-common)
endif()

# ceph_test_mutate
add_executable(ceph_test_mutate
  test_mutate.cc
  )
target_link_libraries(ceph_test_mutate global librados ${BLKID_LIBRARIES}
  ${CMAKE_DL_LIBS})

if(WITH_BLUESTORE AND NOT WIN32)
# test_trans
add_executable(test_trans
  test_trans.cc
  )
target_link_libraries(test_trans os global ${BLKID_LIBRARIES} ${CMAKE_DL_LIBS})
endif()

## Benchmarks


# ceph_omapbench
set(omapbench_srcs
  omap_bench.cc
  )
add_executable(ceph_omapbench
  ${omapbench_srcs}
  )
target_link_libraries(ceph_omapbench
  librados
  ceph-common
  Boost::program_options)

if(WITH_KVS)
  # ceph_kvstorebench
  set(kvstorebench_srcs
    kv_store_bench.cc
    ${CMAKE_SOURCE_DIR}/src/key_value_store/kv_flat_btree_async.cc
    )
  add_executable(ceph_kvstorebench ${kvstorebench_srcs})
  target_link_libraries(ceph_kvstorebench librados global ${BLKID_LIBRARIES} ${CMAKE_DL_LIBS})
  install(TARGETS ceph_kvstorebench DESTINATION bin)
endif(WITH_KVS)

if(NOT WIN32)
  # ceph_objectstore_bench
  add_executable(ceph_objectstore_bench objectstore_bench.cc)
  target_link_libraries(ceph_objectstore_bench os global ${BLKID_LIBRARIES})
endif()

if(${WITH_RADOSGW})
  # test_cors
  set(test_cors_srcs test_cors.cc)
  add_executable(test_cors
    ${test_cors_srcs}
    )
  target_link_libraries(test_cors
    librados
    ${rgw_libs}
    global
    ${BLKID_LIBRARIES}
    ${CURL_LIBRARIES}
    ${EXPAT_LIBRARIES}
    ${CMAKE_DL_LIBS} ${UNITTEST_LIBS})

  # ceph_test_cls_rgw_admin_account_quota_set
  set(test_cls_rgw_admin_account_quota_set_srcs 
    test_rgw_admin_account_quota_set.cc
    test_rgw_admin_helper.cc
  )
  add_executable(ceph_test_cls_rgw_admin_account_quota_set
    ${test_cls_rgw_admin_account_quota_set_srcs}
    )
  target_link_libraries(ceph_test_cls_rgw_admin_account_quota_set
    librados
    ${rgw_libs}
    global
    cls_version_client
    cls_log_client
    cls_refcount_client
    cls_rgw_client
    cls_user_client
    cls_lock_client
    ${BLKID_LIBRARIES}
    ${CURL_LIBRARIES}
    ${EXPAT_LIBRARIES}
    ${CMAKE_DL_LIBS} ${UNITTEST_LIBS} ${CRYPTO_LIBS})

  install(TARGETS
    ceph_test_cls_rgw_admin_account_quota_set
    DESTINATION ${CMAKE_INSTALL_BINDIR})

  # ceph_test_cls_rgw_meta
  set(test_cls_rgw_meta_srcs
    test_rgw_admin_meta.cc
    test_rgw_admin_helper.cc
  )
  add_executable(ceph_test_cls_rgw_meta
    ${test_cls_rgw_meta_srcs}
    )
  target_link_libraries(ceph_test_cls_rgw_meta
    librados
    ${rgw_libs}
    global
    cls_version_client
    cls_log_client
    cls_refcount_client
    cls_rgw_client
    cls_user_client
    cls_lock_client
    ${BLKID_LIBRARIES}
    ${CURL_LIBRARIES}
    ${EXPAT_LIBRARIES}
    ${CMAKE_DL_LIBS} ${UNITTEST_LIBS} ${CRYPTO_LIBS})

  install(TARGETS
    ceph_test_cls_rgw_meta
    DESTINATION ${CMAKE_INSTALL_BINDIR})

  # ceph_test_cls_rgw_log
  set(ceph_test_cls_rgw_log_srcs
    test_rgw_admin_log.cc
    )
  add_executable(ceph_test_cls_rgw_log
    ${ceph_test_cls_rgw_log_srcs}
    )
  target_link_libraries(ceph_test_cls_rgw_log
    librados
    ${rgw_libs}
    global
    cls_version_client
    cls_log_client
    cls_refcount_client
    cls_rgw_client
    cls_user_client
    cls_lock_client
    ${BLKID_LIBRARIES}
    ${CURL_LIBRARIES}
    ${EXPAT_LIBRARIES}
    ${CMAKE_DL_LIBS}
    ${UNITTEST_LIBS}
    ${EXTRALIBS}
    ${CRYPTO_LIBS}
    )

# ceph_test_librgw_file (nfs-like RGW interface)
add_executable(ceph_test_librgw_file
  librgw_file.cc
  )
target_link_libraries(ceph_test_librgw_file
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${ALLOC_LIBS}
  )
install(TARGETS ceph_test_librgw_file DESTINATION ${CMAKE_INSTALL_BINDIR})

add_dependencies(ceph_test_librgw_file
  ceph_test_librgw_file_cd
  ceph_test_librgw_file_gp
  ceph_test_librgw_file_rename
  ceph_test_librgw_file_nfsns
  ceph_test_librgw_file_aw
  ceph_test_librgw_file_marker)

# ceph_test_librgw_file_cd (just the rgw_file create-delete bucket ops)
add_executable(ceph_test_librgw_file_cd
  librgw_file_cd.cc
  )
target_link_libraries(ceph_test_librgw_file_cd
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${ALLOC_LIBS}
  )
install(TARGETS ceph_test_librgw_file_cd DESTINATION ${CMAKE_INSTALL_BINDIR})

# ceph_test_librgw_file_gp (just the rgw_file get-put bucket ops)
add_executable(ceph_test_librgw_file_gp
  librgw_file_gp.cc
  )
target_link_libraries(ceph_test_librgw_file_gp
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${ALLOC_LIBS}
  )
install(TARGETS ceph_test_librgw_file_gp DESTINATION ${CMAKE_INSTALL_BINDIR})

# ceph_test_librgw_file_nfsns (nfs namespace tests)
add_executable(ceph_test_librgw_file_nfsns
  librgw_file_nfsns.cc
  )
target_include_directories(ceph_test_librgw_file_nfsns
  PUBLIC "${LUA_INCLUDE_DIR}"
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw"
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw/driver/rados")
target_link_libraries(ceph_test_librgw_file_nfsns
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${LUA_LIBRARIES}
  ${ALLOC_LIBS}
  )
  target_link_libraries(ceph_test_librgw_file_nfsns Boost::context)
install(TARGETS ceph_test_librgw_file_nfsns DESTINATION ${CMAKE_INSTALL_BINDIR})

# ceph_test_librgw_file_aw (nfs write transaction [atomic write] tests)
add_executable(ceph_test_librgw_file_aw
  librgw_file_aw.cc
  )
target_link_libraries(ceph_test_librgw_file_aw
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${ALLOC_LIBS}
  )
install(TARGETS ceph_test_librgw_file_aw DESTINATION ${CMAKE_INSTALL_BINDIR})

# ceph_test_librgw_file_marker (READDIR with string and uint64 offsets)
add_executable(ceph_test_librgw_file_marker
  librgw_file_marker.cc
  )
target_include_directories(ceph_test_librgw_file_marker
  PUBLIC "${LUA_INCLUDE_DIR}"
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw"
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw/driver/rados")
target_link_libraries(ceph_test_librgw_file_marker
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${LUA_LIBRARIES}
  ${ALLOC_LIBS}
  )
  target_link_libraries(ceph_test_librgw_file_marker Boost::context)
install(TARGETS ceph_test_librgw_file_marker DESTINATION ${CMAKE_INSTALL_BINDIR})

# ceph_test_librgw_file_xattr (attribute ops)
add_executable(ceph_test_librgw_file_xattr
  librgw_file_xattr.cc)
target_include_directories(ceph_test_librgw_file_xattr
  PUBLIC "${LUA_INCLUDE_DIR}"
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw"
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw/driver/rados")
target_link_libraries(ceph_test_librgw_file_xattr
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${LUA_LIBRARIES}
  ${ALLOC_LIBS}
  )
target_link_libraries(ceph_test_librgw_file_xattr Boost::context)

# ceph_test_librgw_file_rename (mv/rename tests)
add_executable(ceph_test_librgw_file_rename
  librgw_file_rename.cc
  )
target_link_libraries(ceph_test_librgw_file_rename
  rgw
  librados
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  ${ALLOC_LIBS}
  )
install(TARGETS ceph_test_librgw_file_rename DESTINATION ${CMAKE_INSTALL_BINDIR})

# ceph_test_rgw_token
add_executable(ceph_test_rgw_token
  test_rgw_token.cc
  )
target_link_libraries(ceph_test_rgw_token
  rgw
  ceph-common
  ${UNITTEST_LIBS}
  ${EXTRALIBS}
  )

# librgw_file_gp (just the rgw_file get-put bucket ops)
add_executable(test_rgw_ldap
  ${CMAKE_SOURCE_DIR}/src/rgw/rgw_ldap.cc
  test_rgw_ldap.cc
  )
target_include_directories(test_rgw_ldap
  SYSTEM PRIVATE "${CMAKE_SOURCE_DIR}/src/rgw"

=== src/crimson/tools/CMakeLists.txt ===
add_executable(crimson-store-nbd
	store_nbd/store-nbd.cc
	store_nbd/tm_driver.cc
	store_nbd/fs_driver.cc
	store_nbd/block_driver.cc
  )
target_link_libraries(crimson-store-nbd
  crimson-os)
install(TARGETS crimson-store-nbd DESTINATION bin)

add_executable(crimson-store-bench
  store_bench/store-bench.cc
  ${PROJECT_SOURCE_DIR}/src/crimson/osd/lsan_suppressions.cc)

target_link_libraries(crimson-store-bench
  crimson-os)
install(TARGETS crimson-store-bench DESTINATION bin)

add_executable(perf-crimson-msgr perf_crimson_msgr.cc)
target_link_libraries(perf-crimson-msgr crimson)

add_executable(perf-async-msgr perf_async_msgr.cc)
target_link_libraries(perf-async-msgr ceph-common global ${ALLOC_LIBS})

add_executable(perf-staged-fltree perf_staged_fltree.cc)
if(WITH_TESTS)
target_link_libraries(perf-staged-fltree crimson-seastore crimson::gtest)
else()
target_link_libraries(perf-staged-fltree crimson-seastore)
endif()

add_executable(crimson-objectstore-tool
  objectstore/objectstore_tool.cc
  objectstore/crimson_objectstore_tool.cc
  ${PROJECT_SOURCE_DIR}/src/crimson/osd/lsan_suppressions.cc)
target_link_libraries(crimson-objectstore-tool
  legacy-option-headers
  crimson
  crimson-os)
install(TARGETS crimson-objectstore-tool DESTINATION bin)

=== src/erasure-code/consistency/CMakeLists.txt ===
add_library(ec_consistency STATIC
  ECReader.cc
  ECEncoder.cc
  ECEncoderSwitch.cc
  Pool.cc
  ConsistencyChecker.cc
  RadosCommands.cc
  ${PROJECT_SOURCE_DIR}/src/osd/ECUtilL.cc
  ${PROJECT_SOURCE_DIR}/src/osd/ECUtil.cc
)

target_link_libraries(ec_consistency
  librados
  global
  json_structures
)

add_executable(ceph_ec_consistency_checker
  ${CMAKE_CURRENT_SOURCE_DIR}/ceph_ec_consistency_checker.cc
  ${PROJECT_SOURCE_DIR}/src/osd/ECUtilL.cc
  ${PROJECT_SOURCE_DIR}/src/osd/ECUtil.cc)
target_link_libraries(ceph_ec_consistency_checker
  librados global ec_consistency)
install(TARGETS
ceph_ec_consistency_checker
  DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/os/bluestore/CMakeLists.txt ===
add_library(bluestore OBJECT
  Allocator.cc
  AllocatorBase.cc
  BitmapFreelistManager.cc
  BlueFS.cc
  bluefs_types.cc
  BlueRocksEnv.cc
  BlueStore.cc
  BlueStore_debug.cc
  simple_bitmap.cc
  bluestore_types.cc
  fastbmap_allocator_impl.cc
  FreelistManager.cc
  StupidAllocator.cc
  BitmapAllocator.cc
  AvlAllocator.cc
  BtreeAllocator.cc
  Btree2Allocator.cc
  HybridAllocator.cc
  Writer.cc
  Compression.cc
  BlueAdmin.cc
  BlueEnv.cc)

target_link_libraries(bluestore
  PRIVATE
    blk heap_profiler kv ${FMT_LIB})

add_dependencies(bluestore compressor_plugins)
if(WITH_LTTNG)
  add_dependencies(bluestore bluestore-tp)
endif()

if(WITH_BLUEFS)
  add_library(bluefs SHARED
    BlueRocksEnv.cc)
  target_include_directories(bluefs SYSTEM PUBLIC
    $<TARGET_PROPERTY:RocksDB::RocksDB,INTERFACE_INCLUDE_DIRECTORIES>)
  target_link_libraries(bluefs global)
  install(TARGETS bluefs DESTINATION lib)
endif()

=== src/os/fs/CMakeLists.txt ===
set(fs_srcs
  FS.cc)

if(HAVE_LIBXFS)
  list_(APPEND fs_srcs
    XFS.cc)
endif()

=== src/test/cls_rbd/CMakeLists.txt ===
# cls_test_cls_rbd
add_executable(ceph_test_cls_rbd
  test_cls_rbd.cc
  $<TARGET_OBJECTS:common_texttable_obj>)
target_link_libraries(ceph_test_cls_rbd
  cls_rbd_client
  libneorados
  librados
  global
  ${UNITTEST_LIBS}
  ${CMAKE_DL_LIBS}
  ${CRYPTO_LIBS}
  ${EXTRALIBS}
  radostest-cxx)
install(TARGETS
  ceph_test_cls_rbd
  DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Homepage: http://ceph.com/
Vcs-Git: git://github.com/ceph/ceph.git
Vcs-Browser: https://github.com/ceph/ceph
Maintainer: Ceph Maintainers <ceph-maintainers@ceph.io>
Uploaders: Ken Dreyer <kdreyer@redhat.com>,
           Alfredo Deza <adeza@redhat.com>,
Build-Depends: automake,
               bison,
               cmake (>= 3.10.2),
               cpio,
               cython3,
               debhelper (>= 10),
               default-jdk,
               dh-exec,
               dh-python,
               flex,
               git,
               golang,
               gperf,
               g++ (>= 11),
               iproute2 <pkg.ceph.check>,
               javahelper,
               jq <pkg.ceph.check>,
               jsonnet <pkg.ceph.check>,
               junit4,
               libarrow-dev <pkg.ceph.arrow>,
               libparquet-dev <pkg.ceph.arrow>,
               libaio-dev,
               libbabeltrace-ctf-dev,
               libbabeltrace-dev,
               libblkid-dev (>= 2.17),
               libc-ares-dev <pkg.ceph.crimson>,
               libcrypto++-dev <pkg.ceph.crimson>,
               libcryptsetup-dev,
               libcap-ng-dev,
               libcap-dev,
               libcunit1-dev,
               libcurl4-openssl-dev,
               libevent-dev,
               libexpat1-dev,
               libffi-dev [!amd64] <pkg.ceph.check>,
               libfmt-dev (>= 6.1.2),
               libfuse-dev,
               libgoogle-perftools-dev [i386 amd64 arm64],
               libgnutls28-dev <pkg.ceph.crimson>,
               libhwloc-dev <pkg.ceph.crimson>,
               libibverbs-dev,
               libicu-dev,
               librdmacm-dev,
               libkeyutils-dev,
               libldap2-dev,
               liblttng-ust-dev,
               liblua5.3-dev,
               liblz4-dev (>= 0.0~r131),
               libnbd-dev,
               libncurses-dev,
               libnss3-dev,
               liboath-dev,
               libnuma-dev,
               libpciaccess-dev <pkg.ceph.crimson>,
               libsctp-dev <pkg.ceph.crimson>,
               libsnappy-dev,
               libsqlite3-dev,
               libssl-dev,
               libtool,
               liblmdb-dev,
               libudev-dev,
               libnl-genl-3-dev,
               libxml2-dev,
               librabbitmq-dev,
               libre2-dev,
               libutf8proc-dev (>= 2.2.0),
               librdkafka-dev,
               libthrift-dev (>= 0.13.0),
               libyaml-cpp-dev (>= 0.6),
               libzstd-dev <pkg.ceph.check>,
               libxmlsec1 <pkg.ceph.check>,
               libxmlsec1-nss <pkg.ceph.check>,
               libxmlsec1-openssl <pkg.ceph.check>,
               libxmlsec1-dev <pkg.ceph.check>,
               libdaxctl-dev (>= 63) <pkg.ceph.pmdk>,
               libndctl-dev (>= 63) <pkg.ceph.pmdk>,
               libpmem-dev <pkg.ceph.pmdk>,
               libpmemobj-dev (>= 1.8) <pkg.ceph.pmdk>,
               libprotobuf-dev <pkg.ceph.crimson>,
               libxsimd-dev <!pkg.ceph.arrow>,
               ninja-build,
               nlohmann-json3-dev,
               patch,
               pkg-config,
               prometheus <pkg.ceph.check>,
               protobuf-compiler <pkg.ceph.crimson>,
               python3-all-dev,
               python3-cherrypy3,
               python3-natsort,
               python3-bcrypt <pkg.ceph.check>,
               tox <pkg.ceph.check>,
               python3-coverage <pkg.ceph.check>,
               python3-dateutil <pkg.ceph.check>,
               python3-grpcio <pkg.ceph.check>,
               python3-jmespath (>=0.10) <pkg.ceph.check>,
               python3-xmltodict <pkg.ceph.check>,
               python3-openssl <pkg.ceph.check>,
               python3-prettytable <pkg.ceph.check>,
               python3-requests <pkg.ceph.check>,
               python3-scipy <pkg.ceph.check>,
               python3-onelogin-saml2 <pkg.ceph.check>,
               python3-jinja2,
               python3-markupsafe,
               python3-setuptools,
               python3-sphinx,
               python3-venv,
               python3-yaml,
               ragel <pkg.ceph.crimson>,
               socat <pkg.ceph.check>,
               systemd,
               systemtap-sdt-dev <pkg.ceph.crimson>,
               uuid-dev <pkg.ceph.check>,
               uuid-runtime,
               valgrind,
               xfslibs-dev,
               xmlstarlet <pkg.ceph.check>,
               nasm [amd64],
               zlib1g-dev,
Standards-Version: 4.4.0

Package: ceph
Architecture: linux-any
Depends: ceph-mgr (= ${binary:Version}),
         ceph-mon (= ${binary:Version}),
         ceph-osd (= ${binary:Version}),
Recommends: ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: linux-any
Depends: binutils,
         ceph-common (= ${binary:Version}),
         logrotate,
         parted,
         psmisc,
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Recommends: btrfs-tools,
            ceph-mds (= ${binary:Version}),
            librados2 (= ${binary:Version}),
            libradosstriper1 (= ${binary:Version}),
            librbd1 (= ${binary:Version}),
            ntp | time-daemon,
            nvme-cli,
            smartmontools,
Replaces: ceph (<< 10),
          ceph-common (<< 0.78-500),
          ceph-test (<< 12.2.2-14),
          python-ceph (<< 0.92-1223),
Breaks: ceph (<< 10),
        ceph-test (<< 12.2.2-14),
        python-ceph (<< 0.92-1223),
Description: common ceph daemon libraries and management tools
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-base-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ceph-base (= ${binary:Version}),
         ${misc:Depends},
Description: debugging symbols for ceph-base
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.
 .
 This package contains the debugging symbols for ceph-base.

Package: cephadm
Architecture: linux-any
Recommends: podman (>= 2.0.2) | docker.io | docker-ce
Depends: adduser (>= 3.11),
	 lvm2,
	 python3,
	 ${python3:Depends},
Description: cephadm utility to bootstrap ceph daemons with systemd and containers
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 The cephadm utility is used to bootstrap a Ceph cluster and to manage
 ceph daemons deployed with systemd and containers.

Package: ceph-mds
Architecture: linux-any
Depends: ceph-base (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ceph-fuse (= ${binary:Version}),
            libcephfs2 (= ${binary:Version}),
Replaces: ceph (<< 0.93-417),
Breaks: ceph (<< 0.93-417),
Description: metadata server for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mds-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ceph-mds (= ${binary:Version}),
         ${misc:Depends},
Description: debugging symbols for ceph-mds
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the debugging symbols for ceph-mds.

Package: ceph-mgr
Architecture: linux-any
Depends: ceph-base (= ${binary:Version}),
         ceph-mgr-modules-core (= ${binary:Version}),
         libsqlite3-mod-ceph (= ${binary:Version}),
         librados2 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Recommends: ceph-mgr-dashboard,
            ceph-mgr-diskprediction-local,
            ceph-mgr-k8sevents,
            ceph-mgr-cephadm
Suggests: python3-influxdb
Replaces: ceph (<< 0.93-417),
Breaks: ceph (<< 0.93-417),
Description: manager for the ceph distributed storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-dashboard
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         ${python3:Depends}
Description: dashboard module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr module, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
 and a detailed feature overview.

Package: ceph-mgr-diskprediction-local
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         ${python3:Depends}
Description: diskprediction-local module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_local module for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-modules-core
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
Replaces: ceph-mgr (<< 15.1.0)
Breaks: ceph-mgr (<< 15.1.0)
Description: ceph manager modules which are always enabled
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains a set of core ceph-mgr modules which are always
 enabled.

Package: ceph-mgr-rook
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Description: rook module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the rook module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to install and configure ceph using
 Rook.

Package: ceph-mgr-k8sevents
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-kubernetes,
         ${misc:Depends},
         ${python3:Depends},
Description: kubernetes events module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the k8sevents module, to allow ceph-mgr to send
 ceph related events to the kubernetes events API, and track all events
 that occur within the rook-ceph namespace.

Package: ceph-mgr-cephadm
